Sandbox: simulate a voice call
curl --request POST \
--url https://api.natural.com/simulations/voice-sessions/{voiceSessionId} \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"data": {
"attributes": {
"action": "pay"
}
}
}
'import requests
url = "https://api.natural.com/simulations/voice-sessions/{voiceSessionId}"
payload = { "data": { "attributes": { "action": "pay" } } }
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({data: {attributes: {action: 'pay'}}})
};
fetch('https://api.natural.com/simulations/voice-sessions/{voiceSessionId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.natural.com/simulations/voice-sessions/{voiceSessionId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'attributes' => [
'action' => 'pay'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.natural.com/simulations/voice-sessions/{voiceSessionId}"
payload := strings.NewReader("{\n \"data\": {\n \"attributes\": {\n \"action\": \"pay\"\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.natural.com/simulations/voice-sessions/{voiceSessionId}")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"data\": {\n \"attributes\": {\n \"action\": \"pay\"\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.natural.com/simulations/voice-sessions/{voiceSessionId}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"data\": {\n \"attributes\": {\n \"action\": \"pay\"\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"id": "vos_019d0a1b2c3d4e5f60718293a4b5c6f0",
"type": "voiceSession",
"attributes": {
"kind": "payment",
"status": "ended",
"referenceId": "call_8842",
"callerPhone": "+14155550123",
"dialUri": null,
"dialExpiresAt": "2026-09-09T18:15:00.000Z",
"returnTarget": "sip:agent-9920@sip.partner.example.com",
"call": {
"startedAt": "2026-09-09T18:01:05.000Z",
"endedAt": "2026-09-09T18:02:50.000Z",
"durationSeconds": 105,
"endedBy": "assistant",
"summary": "The caller confirmed the order and paid. A return transfer was requested.",
"returnRequestedAt": "2026-09-09T18:02:50.000Z"
},
"completedAt": "2026-09-09T18:02:31.000Z",
"payment": {
"outcome": "paid",
"linkSentAt": null,
"failedAttempts": 0,
"failure": null
},
"createdAt": "2026-09-09T18:00:00.000Z",
"updatedAt": "2026-09-09T18:02:50.000Z"
},
"relationships": {
"paymentIntent": {
"data": {
"type": "paymentIntent",
"id": "pmi_019d0a1b2c3d4e5f60718293a4b5c6d7"
}
},
"customerParty": {
"data": {
"type": "party",
"id": "pty_019cd1798d627ad9bc302511c4f2c115"
}
},
"initiatingParty": {
"data": {
"type": "party",
"id": "pty_019cd1798d627ad9bc302511c4f2c116"
}
}
}
}
}Simulations
Sandbox: Simulate a voice call
Drive a Sandbox voice session to a call outcome without placing a phone call
POST
/
simulations
/
voice-sessions
/
{voiceSessionId}
Sandbox: simulate a voice call
curl --request POST \
--url https://api.natural.com/simulations/voice-sessions/{voiceSessionId} \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"data": {
"attributes": {
"action": "pay"
}
}
}
'import requests
url = "https://api.natural.com/simulations/voice-sessions/{voiceSessionId}"
payload = { "data": { "attributes": { "action": "pay" } } }
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({data: {attributes: {action: 'pay'}}})
};
fetch('https://api.natural.com/simulations/voice-sessions/{voiceSessionId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.natural.com/simulations/voice-sessions/{voiceSessionId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'attributes' => [
'action' => 'pay'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.natural.com/simulations/voice-sessions/{voiceSessionId}"
payload := strings.NewReader("{\n \"data\": {\n \"attributes\": {\n \"action\": \"pay\"\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.natural.com/simulations/voice-sessions/{voiceSessionId}")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"data\": {\n \"attributes\": {\n \"action\": \"pay\"\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.natural.com/simulations/voice-sessions/{voiceSessionId}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"data\": {\n \"attributes\": {\n \"action\": \"pay\"\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"id": "vos_019d0a1b2c3d4e5f60718293a4b5c6f0",
"type": "voiceSession",
"attributes": {
"kind": "payment",
"status": "ended",
"referenceId": "call_8842",
"callerPhone": "+14155550123",
"dialUri": null,
"dialExpiresAt": "2026-09-09T18:15:00.000Z",
"returnTarget": "sip:agent-9920@sip.partner.example.com",
"call": {
"startedAt": "2026-09-09T18:01:05.000Z",
"endedAt": "2026-09-09T18:02:50.000Z",
"durationSeconds": 105,
"endedBy": "assistant",
"summary": "The caller confirmed the order and paid. A return transfer was requested.",
"returnRequestedAt": "2026-09-09T18:02:50.000Z"
},
"completedAt": "2026-09-09T18:02:31.000Z",
"payment": {
"outcome": "paid",
"linkSentAt": null,
"failedAttempts": 0,
"failure": null
},
"createdAt": "2026-09-09T18:00:00.000Z",
"updatedAt": "2026-09-09T18:02:50.000Z"
},
"relationships": {
"paymentIntent": {
"data": {
"type": "paymentIntent",
"id": "pmi_019d0a1b2c3d4e5f60718293a4b5c6d7"
}
},
"customerParty": {
"data": {
"type": "party",
"id": "pty_019cd1798d627ad9bc302511c4f2c115"
}
},
"initiatingParty": {
"data": {
"type": "party",
"id": "pty_019cd1798d627ad9bc302511c4f2c116"
}
}
}
}
}Authorizations
Headers
Was this page helpful?